﻿using Syncfusion.DocIO.DLS;
using Syncfusion.DocToPDFConverter;
using Syncfusion.OfficeChartToImageConverter;
using System;
using System.IO;

namespace SyncfusionWCFWordToPdfFonts
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");

            SubstituteFontWithStream();
            //SubsituteFontWithAlternate();
        }

        private static void SubstituteFontWithStream()
        {
            Console.WriteLine("Substitute font with STREAM");

            WordDocument document = new WordDocument("WordFontChartEMFTest.docx", Syncfusion.DocIO.FormatType.Docx);
            document.ChartToImageConverter = new ChartToImageConverter();
            DocToPDFConverter converter = new DocToPDFConverter();
            converter.Settings.EnableFastRendering = true;
            document.FontSettings.SubstituteFont += FontSettings_SubstituteFontWithStream;
            var pdfDocument = converter.ConvertToPDF(document);
            document.FontSettings.SubstituteFont -= FontSettings_SubstituteFontWithStream;

            document.Close();
            converter.Dispose();
            pdfDocument.Save("WordFontChartEMFTest.pdf");
            pdfDocument.Close();
        }

        private static void SubsituteFontWithAlternate()
        {
            Console.WriteLine("Substitute font with COMIC SANS");

            WordDocument document = new WordDocument("tecoFont.docx", Syncfusion.DocIO.FormatType.Docx);
            document.ChartToImageConverter = new ChartToImageConverter();
            DocToPDFConverter converter = new DocToPDFConverter();
            document.FontSettings.SubstituteFont += FontSettings_SubstituteFontWithAlternate;
            var pdfDocument = converter.ConvertToPDF(document);
            document.FontSettings.SubstituteFont -= FontSettings_SubstituteFontWithAlternate;

            document.Close();
            converter.Dispose();
            pdfDocument.Save("tecoFontReplaceComicSans.pdf");
            pdfDocument.Close();
        }

        private static void FontSettings_SubstituteFontWithStream(object sender, SubstituteFontEventArgs args)
        {
            var fontName = args.OriginalFontName;
            string fontStyle = args.FontStyle.ToString();
            string fontFileName = $"{fontName.ToLower().Replace(' ', '_')}-{fontStyle.ToLower()}.ttf";
            var fontPath = $@"Fonts\\{fontFileName}";
            if (File.Exists(fontPath))
            {
                args.AlternateFontStream = new FileStream(fontPath, FileMode.Open);
            }
        }

        private static void FontSettings_SubstituteFontWithAlternate(object sender, SubstituteFontEventArgs args)
        {
            args.AlternateFontName = "Comic Sans MS";
        }
    }
}
